#!/usr/bin/python
#----------------------------
# Config section
#----------------------------

#Define the directory containing the programs to be run (relative to this script)
programsDir="./bin/"
#Define the directory containing the input files (relative to this script)
inputDir="./in/"
#Define the directory containing the input files (relative to this script)
outputDir="./out/"

#-----------------------------------------------
# Do not edit beyond this line
#-----------------------------------------------
from subprocess import *
import re

################################################

def setupOutFile(outFileName):
    
    outFile=file(outputDir+outFileName,"w")
    outFile.write("Dimension[Byte];Time[ms]\n")

    return outFile

################################################

def getMedian(resList):
    
    resList.sort()
    return resList[len(resList)/2]
    
################################################

def run(n):
    
    #Prepare the extraction regexp
    elapsedRE=re.compile("(\d+.\d+)ms")

    ext_iter=5
    cmdLine="./bin/timer_reg " + str(n)
    
    ttime=0
    
    resList = [];
    
    for i in range(ext_iter):
        p = Popen(cmdLine, shell=True, stdin=PIPE, stdout=PIPE, close_fds=True)
        p.wait()
        output = p.stdout.read()
        #Extract
        resList.append(float(elapsedRE.search(output).group(1)))
    median = getMedian(resList)
    return [resList, median]        
    
################################################

def main():
    print "Preparing the output file..."
    allFile=setupOutFile("all.csv")
    medFile=setupOutFile("med.csv")
    print "Done"
    for size in range(1000, 29000, 1000):
        print "Execution of: " +str(size)
        result=run(size)
        for res in result[0]:
            allFile.write(str(4*size*size)+"\t"+str(res)+"\n")
        allFile.flush()
        medFile.write(str(4*size*size)+"\t"+str(result[1])+"\n")
        medFile.flush()
        print "Saved."
    allFile.close()
    medFile.close()
    print "Stop"

#--------------------------------------------------
#Execution starts here
#--------------------------------------------------
if __name__=="__main__":
    main()
    



