#!/usr/bin/python
#----------------------------
# Config section
#----------------------------

#Define the directory containing the programs to be run (relative to this script)
program="./bin/grid_gen"
#Define the directory containing the input files (relative to this script)
inputDir="./in/"

#Define the sizes
#sizes = [128]
#sizes = [128, 256, 512, 1024, 2048, 4000, 8000, 16000, 23000, 28000, 33000, 36000, 41000, 44000, 47000, 50000, 52000]
sizes = [200, 400, 600, 700, 1200, 1400, 1600, 1800, 3000, 5000, 6000, 7000, 9000, 10000, 11000, 12000, 13000, 14000, 15000]

#Define the shapes as dimensional factors: 
#With size s and factors [f,g] -> [s*f, s*g] matrix
shapes=[[0.5,1],[1,1],[1,0.5]]

#-----------------------------------------------
# Do not edit beyond this line
#-----------------------------------------------
from subprocess import *

################################################

def main():
    
    total = 0;
    for shape in shapes:
        for size in sizes:
            m = int(shape[0]*size)
            n = int(shape[1]*size)
            size = m*n*4
            cmdLine = program + " " + str(m) + " " + str(n) + " " +inputDir+str(m)+"."+str(n)+".in"
            if size < 1E3:
               print "Execution of: " + cmdLine + "\tGenerating " + str(size) + " bytes..."
            elif size >= 1E3 and size < 1E6:
               print "Execution of: " + cmdLine + "\tGenerating %.2f KB..." %(size/1E3)
            elif size >= 1E6 and size < 1E9:
               print "Execution of: " + cmdLine + "\tGenerating %.2f MB..." %(size/1E6)
            else:
               print "Execution of: " + cmdLine + "\tGenerating %.2f GB..." %(size/1E9)
            p = Popen(cmdLine, shell=True, stdin=PIPE, stdout=PIPE, close_fds=True)
            p.wait()
            if p.returncode != 0:
               print "Something went wrong at this stage. Return code " + str(p.returncode)
            else:
               print "Done"
               total += size
    if total < 1E3:
       print "Created " + str(total) + " bytes of good data."
    elif total >= 1E3 and total < 1E6:
       print "Created %.2f KB of good data." %(total/1E3)
    elif total >= 1E6 and total < 1E9:
       print "Created %.2f MB of good data." %(total/1E6)
    else:
       print "Created %.2f GB of good data." %(total/1E9)

#--------------------------------------------------
#Execution starts here
#--------------------------------------------------
if __name__=="__main__":
    main()
    



