/**
  * Header file for Tetra PDE solver.
  **/

#ifndef __TETRA_H
#define __TETRA_H

#include <iostream>
#include <cstring>
#include <fstream>

//Assumed maximum temperature. Used by the image writer to scale the colors.
#define MAX_TEMP 100.f

using namespace std;

class Tetra {
	//Pointer to the domain
	float *data;
	//dim_x = columns, dim_y = rows
	int dim_x, dim_y;
	//Domain file pointer
	int fd;
	public:
		Tetra(string ifilename, int m, int n);
		~Tetra();
		int solve(int solver, float *omega, int border_size, int iterations, int threads);
		int saveImage(string title);
		void printArea(int x_start, int x_end, int y_start, int y_end);
		void printGrid();
};

#endif
